modules/m/controllers/ProductController.php
<?php
namespace app\modules\m\controllers;

use app\common\services\AreaService;
use app\common\services\ConstantMapService;
use app\common\services\DataHelper;
use app\common\services\PayOrderService;
use app\common\services\UrlService;
use app\common\services\UtilService;
use app\models\book\Book;
use app\models\City;
use app\models\member\MemberAddress;
use app\models\member\MemberCart;
use app\models\member\MemberFav;
use app\modules\m\controllers\common\BaseController;

class ProductController extends BaseController
{
    public function actionIndex()
    {

        $kw = trim($this->get("kw", ""));
        $sort_field = trim($this->get("sort_field", "default"));
        $sort = trim($this->get("sort", ""));
        $sort = in_array($sort, ['asc', 'desc']) ? $sort : 'desc';

        $list = $this->getSearchData();
        $data = [];
        if ($list) {
            foreach ($list as $_item) {
                $data[] = [
                    'id' => $_item['id'],
                    'name' => UtilService::encode($_item['name']),
                    'price' => UtilService::encode($_item['price']),
                    'main_image_url' => UrlService::buildPicUrl("book", $_item['main_image']),
                    'month_count' => $_item['month_count']
                ];
            }
        }

        $search_conditions = [
            'kw' => $kw,
            'sort_field' => $sort_field,
            'sort' => $sort
        ];

        return $this->render("index", [
            'list' => $data,
            'search_conditions' => $search_conditions
        ]);
    }

    public function actionInfo()
    {
        $id = intval($this->get("id", 0));
        $reback_url = UrlService::buildMUrl("/product/index");
        if (!$id) {
            return $this->redirect($reback_url);
        }

        $info = Book::findOne(['id' => $id]);
        $info['book_pic'] = json_decode($info['book_pic']);
        $pic = $info['book_pic'];
//        if ($info['book_pic']) {
//            array_unshift($pic, $info['main_image']);
//        }

        if (!$info) {
            return $this->redirect($reback_url);
        }

        $has_faved = false;
        if ($this->current_user) {
            $has_faved = MemberFav::find()->where(['member_id' => $this->current_user['id'], 'book_id' => $id, 'type' => 1])->count();
        }

        return $this->render("info", [
            'info' => $info,
            'pic' => $pic,
            'has_faved' => $has_faved
        ]);
    }

    public function actionCart()
    {
        if (\Yii::$app->request->isGet) {
            $list = MemberCart::find()->where(['member_id' => $this->current_user['id']])->orderBy(['id' => SORT_DESC])->all();
            $data = [];
            if ($list) {
                $book_mapping = DataHelper::getDicByRelateID($list, Book::className(), "book_id", "id", ['name', 'price', 'main_image', 'stock']);
                foreach ($list as $_item) {
                    $tmp_book_info = $book_mapping[$_item['book_id']];
                    $data[] = [
                        'id' => $_item['id'],
                        'quantity' => $_item['quantity'],
                        'book_id' => $_item['book_id'],
                        'book_price' => $tmp_book_info['price'],
                        'book_stock' => $tmp_book_info['stock'],
                        'book_name' => UtilService::encode($tmp_book_info['name']),
                        'book_main_image' => UrlService::buildPicUrl("book", $tmp_book_info['main_image'])
                    ];
                }
            }
            return $this->render("cart", [
                'list' => $data
            ]);
        }

        $act = trim($this->post("act", ""));
        $id = intval($this->post("id", 0));
        $book_id = intval($this->post("book_id", 0));
        $quantity = intval($this->post("quantity", 0));
        $date_now = date("Y-m-d H:i:s");

        if (!in_array($act, ["del", "set"])) {
            return $this->renderJSON([], ConstantMapService::$default_syserror, -1);
        }

        if ($act == "del") {
            $cart_info = MemberCart::find()->where(['member_id' => $this->current_user['id'], 'id' => $id])->one();
            if ($cart_info) {
                $cart_info->delete();
            }
            return $this->renderJSON([], "操作成功");
        }


        if (!$book_id || !$quantity) {
            return $this->renderJSON([], ConstantMapService::$default_syserror, -1);
        }

        $book_info = Book::findOne(['id' => $book_id]);
        if (!$book_info) {
            return $this->renderJSON([], ConstantMapService::$default_syserror, -1);
        }

        $cart_info = MemberCart::find()->where(['member_id' => $this->current_user['id'], 'book_id' => $book_id])->one();
        if ($cart_info) {
            $model_cart = $cart_info;
        } else {
            $model_cart = new MemberCart();
            $model_cart->member_id = $this->current_user['id'];
            $model_cart->created_time = $date_now;
        }

        $model_cart->book_id = $book_id;
        $model_cart->quantity = $quantity;
        $model_cart->updated_time = $date_now;
        $model_cart->save(0);

        return $this->renderJSON([], "操作成功");
    }

    /**
     * 收藏
     */
    public function actionFav()
    {
        $act = trim($this->post("act", ""));
        $id = intval($this->post("id", 0));
        $type = intval($this->post('type', 0));
        $book_id = intval($this->post("book_id", 0));

        if (!in_array($act, ["del", "set"])) {
            return $this->renderJSON([], ConstantMapService::$default_syserror, -1);
        }

        if ($act == "del") {
            if (!$id) {
                return $this->renderJSON([], ConstantMapService::$default_syserror, -1);
            }

            $fav_info = MemberFav::find()->where(['member_id' => $this->current_user['id'], 'book_id' => $id, 'type' => $type])->one();

            if ($fav_info) {
                $fav_info->delete();
            }

            return $this->renderJSON([], "取消收藏");
        }

        if (!$book_id) {
            return $this->renderJSON([], ConstantMapService::$default_syserror, -1);
        }

        $has_faved = MemberFav::find()->where(['member_id' => $this->current_user['id'], 'book_id' => $book_id, 'type' => $type])->count();
        if ($has_faved) {
            return $this->renderJSON([], "已收藏", -1);
        }

        $model_fav = new MemberFav();
        $model_fav->member_id = $this->current_user['id'];
        $model_fav->type = $type;
        $model_fav->book_id = $book_id;
        $model_fav->created_time = date("Y-m-d H:i:s");
        $model_fav->save(0);
        return $this->renderJSON([], "收藏成功");
    }

    public function actionOrder()
    {
        if (\Yii::$app->request->isGet) {
            $book_id = intval($this->get("id", 0));
            $quantity = intval($this->get("quantity", 1));
            $sc = $this->get("sc", "product");//sc source 来源
            $product_list = [];
            $total_pay_money = 0;
            if ($book_id) {
                $book_info = Book::find()->where(['id' => $book_id])->one();
                if ($book_info['stock'] < $quantity) {
                    $quantity = $book_info['stock'];
                }
                if ($quantity <= 0) {
                    $quantity = 1;
                }
                if ($book_info) {
                    $product_list[] = [
                        'id' => $book_info['id'],
                        'name' => UtilService::encode($book_info['name']),
                        'quantity' => $quantity,
                        'price' => $book_info['price'],
                        'main_image' => UrlService::buildPicUrl("book", $book_info['main_image']),
                        'stock' => $book_info['stock']
                    ];
                    //运费
                    $who_pay_ship = $book_info['who_pay_ship'];
                    if ($book_info['who_pay_ship'] == 1) {
                        $ship_price = 0;
                    } else {
                        $ship_price = $book_info['ship_price'];
                    }
                    $total_pay_money += $book_info['price'] * $quantity;
                    $total_pay_money += $ship_price;
                }
            } else {//从购物车中获取商品信息
                $cart_list = MemberCart::find()->where(['member_id' => $this->current_user['id']])->all();
                if ($cart_list) {
                    $book_mapping = DataHelper::getDicByRelateID($cart_list, Book::className(), "book_id", "id", ['name', 'price', 'main_image', 'stock']);
                    foreach ($cart_list as $_item) {
                        $tmp_book_info = $book_mapping[$_item['book_id']];
                        $product_list[] = [
                            'id' => $_item['book_id'],
                            'name' => UtilService::encode($tmp_book_info['name']),
                            'quantity' => $_item['quantity'],
                            'price' => $tmp_book_info['price'],
                            'main_image' => UrlService::buildPicUrl("book", $tmp_book_info['main_image'])
                        ];
                        $total_pay_money += $tmp_book_info['price'] * $_item['quantity'];
                    }
                    //购物车没有计算 运费 后期添加 增加
                }
            }


            $address_list = MemberAddress::find()->where(['member_id' => $this->current_user['id'], 'status' => 1])
                ->orderBy(['is_default' => SORT_DESC, 'id' => SORT_DESC])->asArray()->limit(1)->all();
            $data_address = [];
            if ($address_list) {
                $area_mapping = DataHelper::getDicByRelateID($address_list, City::className(), "area_id", "id", ['province', 'city', 'area']);
                foreach ($address_list as $_item) {
                    $tmp_area_info = $area_mapping[$_item['area_id']];

modules/m/views/course/cart.php
<?php
use \app\common\services\UrlService;
use \app\common\services\StaticService;
StaticService::includeAppJsStatic( "/js/m/course/cart.js",\app\assets\MAsset::className() );
?>
<div class="order_pro_box">
    <?php if( $list ):?>
	<ul class="order_pro_list">
        <?php foreach( $list as $_item ):?>
		<li data-price="<?=$_item["book_price"];?>">
			<a href="<?=UrlService::buildMUrl("/product/info",[ 'id' => $_item['book_id'] ]);?>" class="pic" >
                <img src="<?=$_item["book_main_image"];?>" style="height: 100px;width: 100px;"/>
            </a>
			<h2><a href="<?=UrlService::buildMUrl("/product/info",[ 'id' => $_item['book_id'] ]);?>"><?=$_item["book_name"];?></a></h2>
			<div class="order_c_op">
				<b>¥<?=$_item["book_price"];?></b>
				<span class="delC_icon" data="<?=$_item['id'];?>" data-book_id="<?=$_item['book_id'];?>"></span>
				<div class="quantity-form">
					<a class="icon_lower" data-book_id="<?=$_item['book_id'];?>" ></a>
					<input type="text" name="quantity" class="input_quantity" value="<?=$_item['quantity'];?>" readonly="readonly" max="<?=$_item['book_stock'];?>" />
					<a class="icon_plus" data-book_id="<?=$_item['book_id'];?>"></a>
				</div>
			</div>
		</li>
        <?php endforeach;?>
	</ul>
    <?php else:?>
    <div class="no-data">
        好可怜，购物车空空的
    </div>
    <?php endif;?>
</div>
<div class="cart_fixed">
	<a href="<?=UrlService::buildMUrl("/product/order",[ 'sc' => 'cart' ]);?>" class="billing_btn">结算</a>
	<b>合计：<strong>¥</strong><font id="price">0.00</font></b>
</div>

modules/m/views/course/cat.php
<?php
use app\common\services\ConstantMapService;
use app\common\services\UrlService;
use app\common\services\StaticService;

StaticService::includeAppJsStatic( "/js/m/course/cat.js",\app\assets\MAsset::className() );
?>
<?php if( $list ):?>
<ul class="fav_list">
	<?php foreach( $list as $_item ):?>
	<li>
		<a href="<?=UrlService::buildMUrl("/course/cat_info",[ 'id' => $_item['id'] ]);?>">
			<i class="pic"><img src="<?=$_item["avatar"];?>"/></i>
			<h2><?=$_item["name"];?></h2>
            <span class="fav_list_desc"><?=$_item["summary"];?></span>
		</a>
	</li>
	<?php endforeach;?>
</ul>
<?php else:?>
    <section class="layout-nodata">
        <img src="<?=UrlService::buildImageUrl("/nodata.png")?>" width="100%"/>
    </section>
<?php endif;?>

modules/m/views/course/cat_info.php
<?php
use app\common\services\ConstantMapService;
use app\common\services\UrlService;
use app\common\services\UtilService;
use app\common\services\StaticService;
use app\assets\WebAsset;
StaticService::includeAppJsStatic('./js/m/course/cat_info.js', WebAsset::className());
?>
<div class="mem_info">
    <span class="m_pic"><img src="<?=UrlService::buildPicUrl( "course",$info['avatar'] );?>" /></span>
    <p><?=UtilService::encode( $info['name'] );?></p>
</div>
<div class="shelves_box">
    <p class="shelves_box_title">名师介绍 <a class="moreicon" href="javascript:;"><img width="100%" src="<?=UrlService::buildImageUrl("/xiajiantou-icon.png")?>"/></a></p>
    <div class="shelves_box_cont moreicon-cont"><?=UtilService::encode( $info['summary'] );?></div>
</div>
<?php if( $list ):?>
<div class="shelves_box">
	<p class="shelves_box_title">代教课程</p>
    <ul class="fav_list fav_list2">
        <?php foreach( $list as $_item ):?>
            <li>
                <a href="<?=UrlService::buildMUrl("/course/info",[ 'id' => $_item['id'] ]);?>">
                    <i class="pic"><img src="<?=$_item["main_image"];?>"/></i>
                    <h2><?=$_item["name"];?></h2>
                    <span class="fav_list_desc"><?=strip_tags($_item["summary"]);?></span>
                    <div class="tag_box">
                        <?=ConstantMapService::$course_free_mapping[$_item['is_free']]?>
                        <?=ConstantMapService::$course_model_mapping[$_item['model']]?>
                        <label class="tag-price fr"><?php if($_item['is_free'] == 0){echo '￥'.$_item['price'];}?></label>
                    </div>
                </a>
            </li>
        <?php endforeach;?>
    </ul>
</div>
<?php else:?>
<li>
    <div class="no-data">
        <span class="fav_list_desc"><?=ConstantMapService::$default_nodata;?></span>
    </div>
</li>
<?php endif;?>

modules/m/views/course/index.php
<?php
use \app\common\services\UrlService;
use \app\common\services\StaticService;
use app\common\services\ConstantMapService;
StaticService::includeAppJsStatic( "/js/m/course/index.js",\app\assets\MAsset::className() );
?>
<div class="search_header">
    <a href="<?=UrlService::buildNullUrl();?>" class="category_icon"></a>
    <input name="kw" type="text" class="search_input" placeholder="请输入您搜索的关键词" value="<?=$search_conditions['kw'];?>" />
    <i class="search_icon"></i>
</div>
<div class="sort_box">
    <ul class="sort_list clearfix">
        <li>
            <a href="<?=UrlService::buildNullUrl();?>" <?php if(  $search_conditions['sort_field'] == "default" ) :?> class="aon" <?php endif;?> data="default">
                <span>默认</span>
            </a>
        </li>
        <li>
            <a href="<?=UrlService::buildNullUrl();?>" <?php if(  $search_conditions['sort_field'] == "month_count" ) :?> class="aon" <?php endif;?> data="month_count">
                <span>月销量
					<?php if(  $search_conditions['sort_field'] == "month_count" ) :?>
                        <?php if( $search_conditions['sort'] == "asc" ):?>
                            <i class="lowly_icon"></i>
                        <?php else:?>
                            <i class="high_icon"></i>
                        <?php endif;?>
                    <?php else:?>
                        <i></i>
                    <?php endif;?>
                </span>
            </a>
        </li>
        <li>
            <a href="<?=UrlService::buildNullUrl();?>" <?php if(  $search_conditions['sort_field'] == "view_count" ) :?> class="aon" <?php endif;?> data="view_count">
                <span>人气
					<?php if(  $search_conditions['sort_field'] == "view_count" ) :?>
						<?php if( $search_conditions['sort'] == "asc" ):?>
                            <i class="lowly_icon"></i>
						<?php else:?>
                            <i class="high_icon"></i>
						<?php endif;?>
					<?php else:?>
                        <i></i>
					<?php endif;?>
                </span>
            </a>
        </li>
        <li>
            <a href="<?=UrlService::buildNullUrl();?>" <?php if(  $search_conditions['sort_field'] == "price" ) :?> class="aon" <?php endif;?> data="price">
                <span>价格
					<?php if(  $search_conditions['sort_field'] == "price" ) :?>
						<?php if( $search_conditions['sort'] == "asc" ):?>
                            <i class="lowly_icon"></i>
						<?php else:?>
                            <i class="high_icon"></i>
						<?php endif;?>
					<?php else:?>
                        <i></i>
					<?php endif;?>
                </span>
            </a>
        </li>
    </ul>
</div>
<div class="probox">
    <?php if( $list ):?>
        <ul class="prolist">
            <?php foreach( $list as $_item ):?>
            <li>
                <a href="<?=UrlService::buildMUrl("/course/info",[ 'id' => $_item['id'] ]);?>">
                    <i><img src="<?=$_item['main_image_url'];?>"  style="width: 100%;height: 200px;"/></i>
                    <span><?=$_item['name'];?></span>
                    <b><label>月销量<?=$_item['month_count'];?></label>
                        <?=ConstantMapService::$course_model_mapping[$_item['model']]?>
                        <?=ConstantMapService::$course_free_mapping[$_item['is_free']]?>
                        <?=$_item['is_free']==0?'¥'.$_item['price']:'';?></b>
                </a>
            </li>
            <?php endforeach;?>
    </ul>
    <?php else:?>
        <div class="no-data">
            暂无
        </div>
    <?php endif;?>
</div>

modules/m/views/course/info.php
<?php
use \app\common\services\UrlService;
use \app\common\services\UtilService;
use \app\common\services\StaticService;
use app\common\services\ConstantMapService;

StaticService::includeAppJsStatic("/js/m/course/info.js", \app\assets\MAsset::className());
?>
<div class="proban">
    <div id="slideBox" class="slideBox">
        <div class="bd">
            <?php if (!$pic):?>
            <ul>
                <li><img src="<?= UrlService::buildPicUrl("course", $info['main_image']); ?>"/></li>
            </ul>
            <?php else:?>
                <ul>
                    <?php foreach ($pic as $_item_pic):?>
                        <li><img src="<?= UrlService::buildPicUrl("course", $_item_pic); ?>"/></li>
                    <?php endforeach;?>
                </ul>
            <?php endif;?>
        </div>
        <div class="hd">
            <ul>
                <?php if (!$pic):?>
                    <li>1</li>
                <?php else:?>
                    <ul>
                        <?php foreach ($pic as $key=>$_item_pic):?>
                            <li>$key</li>
                        <?php endforeach;?>
                    </ul>
                <?php endif;?>
            </ul>
        </div>
    </div>
    <!--视频-->
    <div class="videobox hidden">
        <video id="videocont" width="100%" preload="auto" >
            <source src="<?=$info['video_url']?>" type="video/mp4"></source>
        </video>
    </div>
</div>

<div class="pro_header">
        <h2><?=UtilService::encode($info['name']); ?></h2>
        <div class="tag_box">
        	<?=ConstantMapService::$course_model_mapping[$info['model']]?>
            <?=ConstantMapService::$course_free_mapping[$info['is_free']]?>
            <label class="tag-price"><?php if($info['is_free'] == 0){echo '¥'.UtilService::encode($info['price']);}?></label>
        </div>
</div>
<div class="pro_warp">
    <p class="shelves_box_title">课程介绍
<!--        <a class="moreicon" href="javascript:;"><img width="100%" src="--><?//=UrlService::buildImageUrl("/xiajiantou-icon.png")?><!--"/></a>-->
    </p>
    <div class="pro_warp_cont moreicon-cont"><?= nl2br($info['summary']); ?></div>
    <?php if($info['model'] == 0):?>
    <p>时间：<?=$info['course_date']?></p>
    <p>地点：<?=$info['course_addr']?></p>
    <p>联系方式：<?=$info['contacts']?></p>
    <?php endif;?>
</div>
<?php if ($has_buyed == 4): ?>
<div class="pro_warp">
    <p class="shelves_box_title">课程二维码</p>
    <div class="QR-code clearfix">
    	<i><img src="<?=UrlService::buildPicUrl('qrcode',$qrcode_image)?>"/></i>
    	<span>用于线下参加课程通过名师验证</span>
    </div>
</div>
<?php endif;?>
<div class="bottom-empty">&nbsp;</div>
<div class="pro_fixed clearfix">
    <?php if ($has_faved): ?>
        <a class="fav has_faved del_fav" href="<?= UrlService::buildNullUrl(); ?>" data="<?=$info['id']; ?>">取消收藏</a>
    <?php else: ?>
        <a class="fav add_fav" href="<?= UrlService::buildNullUrl(); ?>" data="<?= $info['id']; ?>">加入收藏</a>
    <?php endif; ?>
    <?php if ($has_buyed == 1): ?>
        <input type="button" value="查看视频" class="get_video_btn" data="<?= $info['id']; ?>"/>
    <?php elseif ($has_buyed == 2 || $has_buyed == 5): ?>
        <input type="button" value="立即购买" class="order_now_btn" data="<?= $info['id']; ?>"/>
    <?php elseif ($has_buyed == 3): ?>
        <input type="button" value="立即参加" class="sign_now_btn" data="<?= $info['id']; ?>"/>
    <?php elseif ($has_buyed == 4): ?>
<!--        <input type="button" value="二维码" class="get_qrcode_btn" data="--><?//= $info['id']; ?><!--"/>-->
    <?php endif; ?>
    <input type="hidden" name="id" value="<?= $info['id']; ?>">
</div>

modules/m/views/course/order.php
<?php
use \app\common\services\UrlService;
use \app\common\services\StaticService;
use app\common\services\ConstantMapService;

StaticService::includeAppJsStatic("/js/m/course/order.js", \app\assets\MAsset::className());
?>
<div class="order_box">
    <p class="shelves_box_title pt10 pb_10">购买课程</p>
    <?php if ($product_list): ?>
        <ul class="order_list">
            <?php foreach ($product_list as $_item): ?>
                <li data="<?= $_item["id"]; ?>" data-quantity="<?= $_item['quantity']; ?>">
                    <a href="<?= UrlService::buildMUrl("/course/info", ["id" => $_item['id']]); ?>">
                        <!--<i class="pic">
                            <img src="<?= $_item["main_image"]; ?>" style="width: 100px;height: 100px;"/>
                        </i>-->
                        <h2><?= $_item['name']; ?> <!--x <?= $_item['quantity']; ?>--></h2>
                        <div class="tag_box">
                        	<?= ConstantMapService::$course_model_mapping[$_item['model']] ?>
                        	<?= ConstantMapService::$course_free_mapping[$_item['is_free']] ?>
                           	<label class="tag-price"><?php if($_item['is_free'] == 0){echo '￥'.$_item['price'];}?></label>
                        </div>
                    </a>
                </li>
            <?php endforeach; ?>
        </ul>
    <?php endif; ?>
</div>
<div class="addr_form_box_title">请确认个人信息</div>
<div class="addr_form_box">
    <div class="course_form_box">
        <div class="course_input_box">
            <span>姓名</span>
            <input name="nickname" type="text" placeholder="请输入姓名" class="course_input" value=""/>
        </div>
        <div class="course_input_box">
            <span>手机号</span>
            <input name="mobile" type="text" placeholder="请输入手机号" class="course_input" value=""/>
        </div>
    </div>
</div>

<div class="op_box">
    <input type="hidden" name="sc" value="<?= $sc; ?>">
    <input style="width: 100%;" type="button" value="确认订单" class="red_btn do_order"/>
</div>

modules/m/views/course/sign.php
<?php
use app\common\services\StaticService;
use app\common\services\ConstantMapService;

StaticService::includeAppJsStatic("/js/m/course/sign.js", \app\assets\MAsset::className());
?>
<div class="warp_sign_ops">
<input type="hidden" name="msg" value="<?= $msg ? $msg : ConstantMapService::$default_syserror; ?>">
</div>